<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>TruthTable v2.1</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">

<style>
body {
font-family: Verdana, Arial, Helvetica, sans-serif;
font-size:11px;
}

td{
font-family: Verdana, Arial, Helvetica, sans-serif;
font-size:11px;
}

.style1 {
	font-size: 14px;
	font-weight: bold;
	color: #0000FF;
}
</style>
</head>

<body>
<div align="center" class="style1">TruthTable v2.1</div>
<br>
&Uuml;berpr&uuml;fung logischer S&auml;tze mittels Wahrheitstabellen, Ausgabe von disjunktiver und konjunktiver Normalform <br>
<br>
Vorhandene Operatoren in absteigender Bindungsst&auml;rke:<br>
<br>
<table border="1">
  <tr>
    <td><strong>Operator&nbsp;</strong></td>
    <td><strong>Bedeutung</strong></td>
  </tr>
  <tr>
    <td>~A</td>
    <td>Negation</td>
  </tr>
  <tr>
    <td>A&amp;B</td>
    <td>und</td>
  </tr>
  <tr>
    <td>A|B</td>
    <td>oder</td>
  </tr>
  <tr>
    <td>AxB</td>
    <td>XOR (ausschlie&szlig;endes oder)&nbsp;</td>
  </tr>
  <tr>
    <td>A=&gt;B</td>
    <td>A impliziert B </td>
  </tr>
  <tr>
    <td>A&lt;=B</td>
    <td>B impliziert A </td>
  </tr>
  <tr>
    <td>A&lt;=&gt;B</td>
    <td>&Auml;quivalenz</td>
  </tr>
</table>
<br>
<?
$code = $_POST["code"];
?>
<form name="form1" method="post" action="truthtable2.php">
  Zu pr&uuml;fende S&auml;tze:<br>
  <textarea rows="5" cols="40" name="code"><?= $code=="" ? "(A=>B)<=>(~B=>~A)\n~(A&B)<=>~A|~B\nAxB" : $code ?></textarea>
  <input type="submit" value="Prfen">
</form>
<p><br>

  <? //Start Programm

//globale Variablen 

//Operatoren
$binops = array("&", "|", "x", "=>", "<=", "<=>"); //Rangfolge entscheidend!

//Maskierte Operatoren fr reg. Ausdrcke
$binop_trans = array("|" => "\|");

$unop="~"; //Negation

if($code != "") { 
	$codelines = explode(chr(13).chr(10), $code);
	foreach($codelines as $tline)
		ParseCode($tline);
}

function ParseCode($code) { //Einzelnen Code parsen

	global $level; //Formatierung Tabelle
	global $binops, $binop_trans, $unop;
	global $count, $base_arr;
	
	$tcode = strtr($code, array(" " => "")); //Leerzeichen rauswerfen
	
	$formatcode = format_code($tcode);
	
	//Ausdruck ausgeben
	echo "<b>".$formatcode."</b> <br><br>"; //und/oder Zeichen

	//Zeichen erfassen
	$chars = array();	
	for($ch="A"; $ch<="Z" && strlen($ch) == 1;  $ch++) 
		if (strpos($tcode, $ch)!==false) $chars[] = $ch;
		
	$count = count($chars);
	
	if($count==0) {
		echo "Ungltiger Ausdruck (keine Operanden): \"$tcode\"!"; 
		return;
	}

	$base_arr = array(); //zweidimensionaler Array
	
	$arr=array(0);
	create_table($arr);
	$arr=array(1);
	create_table($arr);
	
	$rows = count($base_arr); //Anzahl Reihen
	$results = array(); //Bezeichnerergebnisse
	
	//Alle Bezeichner finden
	$expressions = array();
	$tstr = $tcode;
	
	//Alle Zeichen klammern
	$tstr = preg_replace("'[A-Z0-1]'", "{\\0}", $tstr);
	
	while(!(substr($tstr, 0, 1) == "{" && substr($tstr, -1, 1) == "}") || strpos($tstr, "{", 1) > 0) { //Solange suchen, bis der ganze Ausdruck eine Klammer ist
		
		$curstr = $tstr; //Infinite-Sicherheit
	
		//Unrer Nicht-Operator
		preg_match_all("'$unop\{[^\{]+?\}'", $tstr, $resvals, PREG_SET_ORDER); //Erster Index ist Ergebnisnr.
		for($j=0; $j<count($resvals); $j++) 
			$expressions[] = format_code(clean_pars($resvals[$j][0])); // Klammern "subern" und und/oder-Zeichen
		$tstr = preg_replace("'$unop\{([^\{]+?)\}'", "{".$unop."\\1}", $tstr); //Klammern nach auen setzen
		
		//Binre Operatoren
		foreach($binops as $curop) { //Allgemeine Suche nach {...} OPERATOR {...}
			$curopreg = strtr($curop, $binop_trans); // |-zeichen muss maskiert werden
			preg_match_all("'\{[^\{]+?\}$curopreg\{[^\{]+?\}'", $tstr, $resvals, PREG_SET_ORDER); //Erster Index ist Ergebnisnr.
			for($j=0; $j<count($resvals); $j++) 
				$expressions[] = format_code(clean_pars($resvals[$j][0])); // Klammern "subern" und und/oder-Zeichen
			$tstr = preg_replace("'\{([^\{]+?)\}$curopreg\{([^\{]+?)\}'", "{\\1$curop\\2}", $tstr); //Klammern nach auen setzen
		}
		
		// Alle runden Klammern nach innen, geschweifte nach auen
		while(1) {
			$newstr = preg_replace("'\(\{([^\{]+?)\}\)'", "{(\\1)}", $tstr);  
			if($newstr == $tstr) break;
			$tstr = $newstr;
		}
		
		if($curstr == $tstr) {
			echo "Ungltiger Ausdruck (keine weitere Vereinfachung mglich): \"$tstr\"!"; //Es hatte sich nichts verndert
			return;
		}
	}
	
	$expressions[count($expressions)-1]="[ * ]"; //Sternchen fr Ausdruck selbst
	
	for($i=0; $i<$rows; $i++) { //Reihen durchgehen
	
		$tres = array(); //Bezeichnerergebniszeile
	
		$trans=array();        //"A=>B"  ==> "1=>0"
		for($j=0; $j<$count; $j++) { //Zeichen
			$trans[$chars[$j]] = $base_arr[$i][$j]; //Zeichen einfgen
		}
		$tstr = strtr($tcode, $trans); //Alle Zeichen durch 0/1 ersetzen
		
		//## Generierten Ausdruck prfen ##
		
		while(strlen($tstr) > 1) { //Bei "0" oder "1" aufhren
		
			//Unre Operatoren
			preg_match_all("'".$unop."[0-9]'", $tstr, $resvals, PREG_SET_ORDER); //Erster Index ist Ergebnisnr.
			for($j=0; $j<count($resvals); $j++)
				$tres[] = use_un_operator($resvals[$j][0]); // Nicht-Operator auf Ausdruck anwenden
			$tstr = use_un_operator($tstr);
		
			//Binre Operatoren
			foreach($binops as $curop) {
				$curopreg = strtr($curop, $binop_trans); // |-zeichen muss maskiert werden
				preg_match_all("'[0-9]".$curopreg."[0-9]'", $tstr, $resvals, PREG_SET_ORDER); //Erster Index ist Ergebnisnr.
				for($j=0; $j<count($resvals); $j++)
					$tres[] = use_bin_operator($resvals[$j][0], $curop); // Operator auf Ausdruck anwenden
				$tstr = use_bin_operator($tstr, $curop);
			}		

			//Alle Klammern raus
			while(1) {
				$newstr = preg_replace("'\(([0-9])\)'", "\\1", $tstr); 
				if($newstr == $tstr) break;
				$tstr = $newstr;
			}
			
		}
		
		$results[] = $tres; //Ergebnisse hinzufgen
	}
	
	// ### Ergebnistabelle erstellen
	$restable=array();
	for($i=0; $i<$count; $i++)                $restable[0][$i]        = $chars[$i]; //Zeichennamen in Tabelle
	for($i=0; $i<count($expressions); $i++)   $restable[0][$count+$i] = $expressions[$i];
	
	//Reihen
	for($i=0; $i<$rows; $i++) {
	
		for($j=0; $j<$count; $j++) { //Zeichen-Werte
			$restable[$i+1][$j] = $base_arr[$i][$j];
		}
		
		for($j=0; $j<count($expressions); $j++) {  //Ausdruck-Ergebnisse
			$restable[$i+1][$j+$count] = $results[$i][$j];
		}
	}
	
	// ### Tabelle ausgeben
	echo "<table border='1'>";
	for($i=0; $i<count($restable); $i++) {
		echo "<tr>";
		for($j=0; $j<count($restable[$i]); $j++) {
			echo "<td ".($i==0 ? "style='padding-top:".($level*2)."px'" : "").">";
			if ($j == count($restable[$i])-1 || $i < 1) echo "<b>";
			if ($i == 0)
				echo $restable[$i][$j]; //Bezeichner
			else
				echo $restable[$i][$j] ? "w" : "f";
			if ($j == count($restable[$i])-1 || $i < 1) echo "</b>";
			echo "</td>";
		}
		echo "</tr>";
	}
	echo "</table>";
	
	//Ergebnis ermitteln
	$j=count($restable[0])-1; //Erg. Spalte
	
	$finalres = true;
	$somethingtrue = false; //Irgendwas war
	for($i=1; $i<count($restable); $i++) 
		if (!$restable[$i][$j]) {
			$finalres = false; //Irgendwas falsch
		} else { 
			$somethingtrue = true; //Irgendwas richtig
		}
		
		
	echo "<br>";
		
	if ($finalres)
		echo "<b>Der Satz $formatcode ist eine Tautologie!</b>";
	else if ($somethingtrue) 
		echo "<b>Der Satz $formatcode ist keine Tautologie!</b>";
	else
		echo "<b>Der Satz $formatcode ist falsch!</b>";
		
	echo "<br><br>";
	
	getnormalforms($chars, $restable);
	
	echo "<br><br>";
	
} //Ende Parsing-Funktion

//ABC... Tabelle in $base_arr erstellen
function create_table($arr) {

	global $count, $base_arr;

	if (count($arr)==$count) {
		$base_arr[] = $arr;
		return;
	}

	$tarr = $arr; //Kopie des Arrays
	$tarr[] = 0;
	
	create_table($tarr);
	$tarr = $arr; 
	$tarr[] = 1;
	create_table($tarr);
}

// Operatoren

//Unrer Operator (nur "nicht")
function use_un_operator($expr) {
	$trans = array("~1" => "0",
				   "~0" => "1");
	return strtr($expr, $trans);
}

//Binrer Operator
function use_bin_operator($expr, $op) {
	switch($op) {
	case "=>": //impliziert
		$trans = array("1=>1" => "1",
					   "1=>0" => "0", //true=>false !
					   "0=>1" => "1",
					   "0=>0" => "1");
					   break;
	case "<=": //folgt aus
		$trans = array("1<=1" => "1",
					   "1<=0" => "1", 
					   "0<=1" => "0", //true=>false !
					   "0<=0" => "1");
					   break;
	case "<=>": //uquivalent
		$trans = array("1<=>1" => "1",
					   "1<=>0" => "0", 
					   "0<=>1" => "0", 
					   "0<=>0" => "1");
					   break;
	case "&": //und
		$trans = array("1&1" => "1",
					   "1&0" => "0", 
					   "0&1" => "0", 
					   "0&0" => "0");
					   break;   
	case "|": //oder
		$trans = array("1|1" => "1",
					   "1|0" => "1", 
					   "0|1" => "1", 
					   "0|0" => "0");
					   break;  
	case "x": //XOR
		$trans = array("1x1" => "0",
					   "1x0" => "1", 
					   "0x1" => "1", 
					   "0x0" => "0");
					   break;  
	}
	return strtr($expr, $trans); 
}

//Saubere Klammern zur Ausgabe:

function clean_pars($val) {
	$trans_par = array("{" => "", "}" => ""); //geschw. Klammern entfernen
	return strtr($val, $trans_par); // preg_replace("'\(([A-Z])\)'", "\\1", $tstr); // "sinnlose" Klammern rauswerfen
}		

//und/oder Zeichen ersetzen
function format_code($val) {

	global $level; //Tabelle danach formatieren
	
	$ss="<span style='letter-spacing:-2px'>";
	$ss1="<span style='letter-spacing:-1px;font-size:9px;'>";
	$es="</span>";
	
	$pos = 0;
	
	$level = 0;
	
	for($level=0; $level<10; $level++) 
	{
		$count = 0; //Anzahl Ersetzungen
		$pos = 0;
		while(($pos = strpos($val, "~", $pos)) !== false)
		{
			if( in_array(substr($val, $pos+1, 1), range("A", "Z")))
			{
				$val = substr($val, 0, $pos) . "{" . $level . substr($val, $pos+1, 1) . $level . "}" . substr($val, $pos+2);
				$start = $pos + 1;
				$end   = $pos + 1; //Einzelnes Zeichen
				$count++;
			}
			else if (substr($val, $pos+1, 1) == "~") //Mehrfache Verneinung
			{
				$pos++;
			}
			else   //Klammer
			{
				$bflag = (substr($val, $pos+1, 1) == "{"); //Klammern innen bernehmen
				$start = $pos + 2;
				$braces = 1;
				for ($i = $pos + 2; $braces > 0; $i++) {
					if      (substr($val, $i, 1) == "(" || substr($val, $i, 1) == "{" ) $braces++;
					else if (substr($val, $i, 1) == ")" || substr($val, $i, 1) == "}" ) $braces--;
					else if (substr($val, $i, 1) == "~" ) {
						$pos++;
						continue 2; //Nchste Position
					}
				} // i ist nun ein Zeichen nach dem Abbruch
				//Ersetzen
				$val = substr($val, 0, $pos) . "{" . $level . ($bflag ? "{" : "") . substr($val, $pos+2, $i-$pos-3) . ($bflag ? "}" : "") . $level . "}" . substr($val, $i);
				$count++;
			}
		}
		if (!$count) break; //Keine weiteren Ersetzungen
	}
	
	// u/o/etc ersetzen
	$trans = array("&" => " &and; ",
	               "|" => " &or; ",
				   "~" => " &not; ",
				   "x" => " $ss1"."XOR$es ");
	$val = strtr($val, $trans);
	
	//Formatieren (Negationen)
	for($i=0; $i<$level; $i++) 
		$val = preg_replace("/\{$i(.+?)$i\}/", "<span style='border-width:1px 0 0 0;border-style:solid; border-color:black; padding-top:".($i*2)."px;'>\\1</span>", $val);
	
	return $val;	
}

//// NEU hardencode

function getnormalforms($chars, $restable) 
{
	
	$f = 0; //falsche
	$t = 0; //wahre
	$j = count($restable[0])-1;
	for($i=1; $i<count($restable); $i++) {
		if ($restable[$i][$j]) $t++;
		else                   $f++;
	}
	
	
	if (!$t || !$f) //wahr oder falsch
	{
		echo "Normalform: ";
		if      (!$t) echo "f";
		else if (!$f) echo "w";
	
	}
	else 
	{
	
		$out = "";
		$i = 0;
		
		// Disjunktive Normalform --> wahre nehmen
			
		for($n=1; $n<=$t; $n++) {
			$finished = false;
			for ($i++; !$restable[$i][$j]; $i++) { //nchstes wahres
				if($i == count($restable)-1) {
					$finished = true;
					break;
				}
			}
			if ($finished) break;
				
			$out .= "(";
			
			for($m=0; $m<count($chars); $m++) {
				$out .= ($restable[$i][$m] ? "" : "~") . $chars[$m];
				if ($m<count($chars)-1) $out .= "&";
			}
				
			$out .= ")";
			if ($n < $t) $out .= "|";
		}
		
		echo "Disjunktive Normalform: " . format_code($out) . "<br><br>&nbsp;&nbsp;&nbsp;&nbsp; als Code: $out<br><br>";
		
			
		// Konjunktive Normalform --> falsche nehmen (aber negiert!!!)
		$out = "";
		$i = 0;
		
		for($n=1; $n<=$f; $n++) {
			$finished = false;
			for ($i++; $restable[$i][$j]; $i++) { //nchstes falsches
				if($i == count($restable)-1) {
					$finished = true;
					break;
				}
			}
			if ($finished) break;
				
			$out .= "(";
			
			for($m=0; $m<count($chars); $m++) {
				$out .= (!$restable[$i][$m] ? "" : "~") . $chars[$m];
				if ($m<count($chars)-1) $out .= "|";
			}
				
			$out .= ")";
			if ($n < $f) $out .= "&";
		}
		
		echo "Konjunktive Normalform: " . format_code($out) . "<br><br>&nbsp;&nbsp;&nbsp;&nbsp; als Code: $out";
	
	} // Ende tatschliche Normalform (nicht w oder f)
	
	echo "<br>";

} //Ende Normalform

?>
  <br>
  <em>TruthTable v2.1, (c) Copyright 2005-2010 by Patrick Roocks, <a href="http://www.p-roocks.de">www.p-roocks.de</a><br>
</em>(geschrieben in PHP5 mit regul&auml;ren Ausdr&uuml;cken)<br>
<br>
<a href="http://www.p-roocks.de/files/tt.zip">Download PHP-Script</a></p>
</body>
</html>
